# -*- coding: utf-8 -*-
"""
Created on Thu Jul 11 13:51:16 2013

@author: Christian
"""

#from schemaobject import SchemaObject

from PyQt4.QtCore import *
from PyQt4.QtGui import *

#include <QFileSystemModel>
#include <QDebug>

#include "library/input/loadviconblock.h"

#define DEBUG

from canevasschema import CanevasSchema
from processblock import ProcessBlock

import Pyro4
Pyro4.config.HMAC_KEY='sdfsdf7s98d7f98sd79f!?fghJLIHJKH'    


class MdiSubWindow(QMdiSubWindow):
    def __init__(self, parent) :
        QMdiSubWindow.__init__(self, parent)


    def init(self):
        self.canevas = CanevasSchema(self)
    
        self.setWidget(self.canevas);
        
        
        

    def drawStructureBlock(self, structureBlock) :
        
        processBlock = ProcessBlock(self.canevas, structureBlock["name"])       
        for blockInput in structureBlock["inputs"]:
            processBlock.addInputPort(blockInput)
        for blockOutput in structureBlock["outputs"]:
            processBlock.addOutputPort(blockOutput)
        processBlock.guessBestGeometry()

        self.canevas.addBlock(processBlock)
        
        for nextBlock in structureBlock["nexts"]:
            self.drawStructureBlock(nextBlock) 
        
        
    def loadSchemaFromScheduler(self, schedulerName):

        try:
            Pyro4.locateNS()
        except : #errors.PyroError:
            print 'Error: No name server could be located located.'
            return
        
        
        self.scheduler = Pyro4.Proxy("PYRONAME:" + schedulerName)            
        
        self.drawStructureBlock(self.scheduler.getSchemaStructure())
            
        
    
        """
        connect(self.canevas.get(), SIGNAL(selectedSchemaObjectChanged(SchemaObjectPtr)),
                this, SLOT(emitSelectedSchemaObjectChanged(SchemaObjectPtr)));
    
        connect(self.canevas.get(), SIGNAL(schemaLogicChanged(vector<SchemaObjectPtr>&)),
                this, SLOT(emitSchemaLogicChanged(vector<SchemaObjectPtr>&)));
        """


"""
void MdiSubWindow::emitSelectedSchemaObjectChanged(SchemaObjectPtr r_objectSelected)
{
    emit selectedSchemaObjectChanged(r_objectSelected);
}

void MdiSubWindow::emitSchemaLogicChanged(vector<SchemaObjectPtr>& r_objectChanged)
{
    emit schemaLogicChanged(r_objectChanged);
}
"""




class MainWindow(QMainWindow) :
    def __init__(self, parent=None):
        QMainWindow.__init__(self, parent)

        self.mdiArea = QMdiArea()
        
        #self.layout =  QVBoxLayout()
        #self.layout.addWidget(self.mdiArea) 
        #self.setLayout(self.layout)
        self.setCentralWidget(self.mdiArea)
        
        """ 
           ui(new Ui::MainWindow), m_libraryTreeView(this),
            m_wdgProcessBlock(this), m_libraryModel(shared_ptr<QWidget>()),
            m_dockProperty("Object properties", this),
            m_dockScript("Script representation", this)
        {
        
            ui->setupUi(this);
        }
    
        void MainWindow::buildDockProperty()
        {
            m_dockProperty.setWidget(&m_wdgProcessBlock);
        }
        """
        
    
        #///////////////////// eventually to include in a function call creating mdi windows
    
        #MDI
        self.windows = {"Untitled": MdiSubWindow(self)}
        self.windows["Untitled"].init()
        self.windows["Untitled"].setWindowTitle("Untitled")
        self.windows["Untitled"].showMaximized()
        self.mdiArea.addSubWindow(self.windows["Untitled"])
        
        self.windows["Untitled"].loadSchemaFromScheduler("scheduler_memoire")           
        print self.windows["Untitled"].scheduler.getSchemaStructure()
        
    
        """
        connect(m_windows["Untitled"].get(), SIGNAL(selectedSchemaObjectChanged(SchemaObjectPtr)),
                this, SLOT(setActiveObject(SchemaObjectPtr)));
    
    
        connect(m_windows["Untitled"].get(), SIGNAL(schemaLogicChanged(vector<SchemaObjectPtr>&)),
                this, SLOT(updateScriptRepresentation(vector<SchemaObjectPtr>&)));
    
    
        ///////////////////////////////////////////////////////////
        """
        """
        makeMenus();
        buildDockProperty();
    
        m_dockScript.setWidget(&m_scriptWidget);
    
        tabifyDockWidget(ui->dockDocumentation, &m_dockProperty);
        tabifyDockWidget(&m_dockProperty, &m_dockScript);
        ui->dockDocumentation->show();
        ui->dockDocumentation->raise();
    
    
        m_libraryModel.buildBaseLibraries();
    
    /*    QStandardItem *parentItem = m_libraryModel.invisibleRootItem();
        for (int i = 0; i < 4; ++i) {
            QStandardItem *item = new QStandardItem(QString("item %0").arg(i));
            parentItem->appendRow(item);
            parentItem = item;
        }
    */
    
        ui->dockLibrary->setWidget(&m_libraryTreeView);
        m_libraryTreeView.setModel(&m_libraryModel);
    
        ui->dockDocumentation->setWidget(&m_docView);
    
        m_docEngine.setDocView(&m_docView);
    
    
        showMaximized();
    
        m_libraryModel.init(shared_from_this());#include "mainwindow.h"
    }

void MainWindow::addCustomBlock()
{


}


void MainWindow::makeMenus()
{
    m_addCustomBlockAct = new QAction(tr("Add a custom block"), this);
    m_addCustomBlockAct->setStatusTip(tr("Add a custom block"));
    connect(m_addCustomBlockAct, SIGNAL(triggered()), this, SLOT(addCustomBlock()));

    ui->menuLibrary->addAction(m_addCustomBlockAct);
}



void MainWindow::deleteMenus()
{
    delete m_addCustomBlockAct;
}


MainWindow::~MainWindow()
{
    /*
    // Free the memory of every mdi windows created.
    typedef map<string, MdiSubWindow*> map_t;
    BOOST_FOREACH(map_t::value_type &i, m_windows)
        delete i.second;
*/
    delete ui;
    deleteMenus();
}

CanevasSchemaPtr MainWindow::getCurrentCanevas()
{
    return ((MdiSubWindow*)(ui->mdiArea->currentSubWindow()))->getCanevas();
}


void MainWindow::setActiveObject(SchemaObjectPtr r_schemaObject)
{
    m_wdgProcessBlock.setActiveObject(r_schemaObject);
}


void MainWindow::updateScriptRepresentation(vector<SchemaObjectPtr>& r_objectChanged)
{
    m_scriptWidget.updateDisplay(r_objectChanged);
}



        """