# -*- coding: utf-8 -*-
"""
Created on Wed May 29 14:14:39 2013

@author: REVESTECH
"""

from PyBlockWork.scheduler import Scheduler

###############################################################################
# Processing schema definition
###############################################################################


from Pyro4 import threadutil
from Pyro4 import naming
import Pyro4
import sys, os
import time
from threading import Thread

from PyBlockWork.framework import fromPrevious
from PyBlockWork.scheduler import Scheduler
from PyBlockWork.blocs import globBWM, SigBdfConversionBWM, GetChannelListBWM, SpindlePropagationBWM





class NameServer(threadutil.Thread):
    def __init__(self, hostname):
        super(NameServer,self).__init__()
        self.setDaemon(1)
        self.hostname=hostname
        self.started=threadutil.Event()

    def run(self):
        self.uri, self.ns_daemon, self.bc_server = naming.startNS(self.hostname)
        self.started.set()
        self.ns_daemon.requestLoop()


def startNameServer(host):
    ns=NameServer(host)
    ns.start()
    ns.started.wait()
    return ns


if __name__ == '__main__': 
    
    # Configuring Pyro
    sys.excepthook = Pyro4.util.excepthook    
    Pyro4.config.HMAC_KEY='sdfsdf7s98d7f98sd79f!?fghJLIHJKH'     
    
    # Starting the name server
    print 'Waiting for the Pyro nameserver to start...'
    nameserver=startNameServer("localhost")    
    time.sleep(2.5)



    Pyro4.config.THREADPOOL_MAXTHREADS = 500
    # Starting the scheduler
    print "Waiting for the scheduler to start..."
    scheduler = Scheduler("C:\\DATA\\Memoire\\schedulerRegister.bin", 15)
     
    deamon = Pyro4.Daemon()
    ns = Pyro4.locateNS()
    ns.register("scheduler", deamon.register(scheduler))

    deamon.requestLoop()
        
    print "Closing scheduler..."
        